<?
sapp_include_once('common.php');

function form_handler()
{
	$valid = true;

	// check ssl
	$ssl = sapp_get_submit_value('ssl');
	switch ($ssl) {
		case 'true':
			sapp_set_ssl(true);
			break;

		default:
			sapp_set_ssl(false);
			break;
	}

	// check install_prefix
	$install_prefix = sapp_get_submit_value('install_prefix');
	if (in_array($install_prefix, array(".", "/", "./")))
	{
		$ret = (function_exists('sapp_check_install_prefix'))? sapp_check_install_prefix(SITEAPP_PREFIX_ROOT) : false;
		if (false===$ret || false === in_array($ret, array(SITEAPP_DIR_NOT_EXISTS, SITEAPP_DIR_USED_BY_UNKNOWN)))
		{
			sapp_set_wrong('install_prefix', msg('install_prefix__invalid_name'));
			$valid = false;
		}
	}

	switch (sapp_set_install_prefix($install_prefix)) {

		case SITEAPP_DIR_NOT_EXISTS:
			break;

		case SITEAPP_DIR_USED_BY_UNKNOWN:
			sapp_set_wrong('install_prefix', msg('install_prefix__already_exists'));
			$valid = false;
			break;			

		case SITEAPP_DIR_INVALID_NAME:
			sapp_set_wrong('install_prefix', msg('install_prefix__invalid_name'));
			$valid = false;
			break;

		case SITEAPP_DIR_USED_BY_SITEAPP:
			sapp_set_wrong('install_prefix', msg('install_prefix__used_by_sapp'));
			$valid = false;
			break;
	}

	//check db name
	$oscommerce_dbname = sapp_get_submit_value('oscommerce_dbname');
	if (!check_dbName($oscommerce_dbname)) {
		sapp_set_wrong('oscommerce_dbname', msg('invalid_value'));
		$valid = false;
	}
	
	sapp_set_param('oscommerce_dbname', $oscommerce_dbname);

	if (sapp_is_database_exists($oscommerce_dbname, 'mysql')) {
		sapp_set_wrong('oscommerce_dbname', msg('db__database_already_exists'));
		$valid = false;
	}
	
	//check db user
	$oscommerce_dbuser = sapp_get_submit_value('oscommerce_dbuser');
	if (!check_dbUserName($oscommerce_dbuser)) {
		sapp_set_wrong('oscommerce_dbuser', msg('invalid_value'));
		$valid = false;
	}

	sapp_set_param('oscommerce_dbuser', $oscommerce_dbuser);

	//check db passwd
	$oscommerce_dbpasswd = sapp_get_submit_value('oscommerce_dbpasswd');
	$oscommerce_dbconfirm = sapp_get_submit_value('oscommerce_dbconfirm');
	if ('' == $oscommerce_dbpasswd) {
		if (!sapp_get_param('oscommerce_dbpasswd')) {
			sapp_set_wrong('oscommerce_dbpasswd', msg('password__empty'));
			$valid = false;
		} else {
			$oscommerce_dbpasswd = sapp_get_param('oscommerce_dbpasswd');
		}
	} elseif ($oscommerce_dbpasswd != $oscommerce_dbconfirm) {
		sapp_set_wrong('oscommerce_dbpasswd', msg('password__not_match'));
		sapp_set_wrong('oscommerce_dbconfirm', msg('password__not_match'));
		$valid = false;
	} else {
		sapp_set_param('oscommerce_dbpasswd', $oscommerce_dbpasswd);
	}

	if (sapp_is_database_user_exists($oscommerce_dbname, 'mysql', $oscommerce_dbuser, $oscommerce_dbpasswd)) {
		sapp_set_wrong('oscommerce_dbuser', msg('db__database_user_already_exists'));
		$valid = false;
	}
	
	//check admin login
	$oscommerce_admin_login = sapp_get_submit_value('oscommerce_admin_login');
	if (!check_sys_login($oscommerce_admin_login)) {
		sapp_set_wrong('oscommerce_admin_login', msg('invalid_value'));
		$valid = false;
	}

	sapp_set_param('oscommerce_admin_login', $oscommerce_admin_login);

	//check admin password
	$oscommerce_admin_passwd = sapp_get_submit_value('oscommerce_admin_passwd');
	$oscommerce_admin_confirm = sapp_get_submit_value('oscommerce_admin_confirm');
	if ('' == $oscommerce_admin_passwd) {
		if (!sapp_get_param('oscommerce_admin_passwd')) {
			sapp_set_wrong('oscommerce_admin_passwd', msg('password__empty'));
			$valid = false;
		} else {
			$oscommerce_admin_passwd = sapp_get_param('oscommerce_admin_passwd');
		}
	} elseif ($oscommerce_admin_passwd != $oscommerce_admin_confirm) {
		sapp_set_wrong('oscommerce_admin_passwd', msg('password__not_match'));
		sapp_set_wrong('oscommerce_admin_confirm', msg('password__not_match'));
		$valid = false;
	} elseif (!check_sys_passwd($oscommerce_admin_login, $oscommerce_admin_passwd)) {
		sapp_set_wrong('oscommerce_admin_passwd', msg('invalid_value'));
		$valid = false;
	} else {
		sapp_set_param('oscommerce_admin_passwd', $oscommerce_admin_passwd);
	}

	if (!$valid) {
		sapp_set_warning(msg('invalid_values'));
		return 1;
	}
		
	if (!sapp_create_database($oscommerce_dbname, 'mysql')) {
		sapp_set_wrong('oscommerce_dbname', msg('db__unable_to_create'));
		return 1;
	}

	if (!sapp_create_database_user($oscommerce_dbname, 'mysql', $oscommerce_dbuser, $oscommerce_dbpasswd)) {
		sapp_set_wrong('oscommerce_dbuser', msg('db__unable_to_create'));
		return 1;
	}

	// set application URL
	sapp_set_param('application_url', sapp_get_param('install_prefix'));

	return 2;
}
?>
